import pygame

from entities import *

import math


class Baddie(Agent):
  def __init__(self,pos,angle,level,image,shot_image):
    size = 0
    
    health = 0
    speed  = 0
    
    if level == 0:
      size   = 16
      health = 2
      speed  = 5
    if level == 1:
      size   = 26
      health = 3
      speed  = 4
    if level == 2:
      size   = 34
      health = 6
      speed  = 2
    
    self.level = level
    
    self.attack_timer = 0
    
    self.exploding = False
    self.frame     = 0
    
    super(Baddie,self).__init__(pos,size,angle,health,speed,image,shot_image)
    
  
  def attack(self):
    shot_origin = list(self.rect.center)
    
    shot_origin[0] += math.cos(math.radians(self.heading)) * (self.rect.width // 2)
    shot_origin[1] -= math.sin(math.radians(self.heading)) * (self.rect.height // 2)
    
    speed  = self.level + 6
    damage = self.level + 1
    
    new_bullet = Projectile(shot_origin,8,self.heading,speed,damage,self.shot_image)
    
    new_bullet.world = self.world
    
    self.world.projectiles['Baddie'].append(new_bullet)
    
  
  def update(self):
    goal_delta = list(self.world.player.rect.center)
    
    goal_delta[0] -= self.rect.centerx
    goal_delta[1] -= self.rect.centery
    
    goal_heading = math.degrees(math.atan2(-(goal_delta[1]),goal_delta[0]))
    
    dx = math.cos(math.radians(goal_heading)) * self.speed
    dy = math.sin(math.radians(goal_heading)) * self.speed
    
    dy *= -1
    
    self.heading = goal_heading
    
    dist_to_player = math.sqrt((goal_delta[0] ** 2)+(goal_delta[1] ** 2))
    
    if dist_to_player > 60:
      self.move(dx,dy)
    
    self.attack_timer -= 1
    
    if self.attack_timer < 0:
      self.attack_timer = 0
    
    if dist_to_player <= 250:
      if self.attack_timer <= 0:
        self.attack_timer = 20
        
        self.attack()
        
    
  
