import pygame

from   entities import *

import math


class Player(Agent):
  def __init__(self,pos,angle,image,shot_image):
    super(Player,self).__init__(pos,22,angle,6,10,image,shot_image)
    
    self.cooldownTimer = 0
    
  
  
  def attack(self):
    if self.cooldownTimer > 0:
      return None
    
    self.cooldownTimer = 6
    
    shot_origin = list(self.rect.center)
    
    shot_origin[0] += math.cos(math.radians(self.heading)) * 10
    shot_origin[1] -= math.sin(math.radians(self.heading)) * 10
    
    new_bullet = Projectile(shot_origin,8,self.heading,10,1,self.shot_image)
    
    new_bullet.world = self.world
    
    
    self.world.projectiles['Player'].append(new_bullet)
    
  
  
  def update(self,controls):
    dx = dy = 0
    
    if controls['Right']:
      dx += self.speed
    
    if controls['Left']:
      dx -= self.speed
    
    if controls['Up']:
      dy -= self.speed
    if controls['Down']:
      dy += self.speed
    
    self.cooldownTimer -= 1
    
    if controls['Fire']:
      self.attack()
    
    self.move(dx,dy)
    
    
    mouse_delta = [0,0]
    
    mouse_delta[0] = pygame.mouse.get_pos()[0] - self.rect.centerx
    mouse_delta[1] = pygame.mouse.get_pos()[1] - self.rect.centery
    
    self.heading = math.degrees(math.atan2(-(mouse_delta[1]), mouse_delta[0]))
    
    
  
