import pygame



class GameWorld(object):
  def __init__(self,player,terrain,baddies):
    self.player = player
    
    player.world = self
    
    self.baddies = baddies
    
    for dude in self.baddies:
      dude.world = self
    
    self.massive_terrain = []
    
    self.area = pygame.Rect(0,0,500,500)
    
    self.massive_terrain = []
    self.floor_terrain   = []
    
    for block in terrain:
      if block.massive:
        self.massive_terrain.append(block)
      else:
        self.floor_terrain.append(block)
      
    
    self.projectiles = {'Player':[],'Baddie':[]}
    
  
  terrain = property(lambda self:self.massive_terrain + self.floor_terrain)
  
  all_projectiles = property(
                  lambda self:self.projectiles['Player'] + self.projectiles['Baddie'])
  
  
  def update(self,controls):
    self.player.update(controls)
    
    for bullet in self.projectiles['Player']:
      bullet.update()
      
      if not bullet.alive and not bullet.exploding:
        self.projectiles['Player'].remove(bullet)
        
      
    
    for dude in self.baddies:
      dude.update()
      
      if dude.health <= 0 and not dude.exploding:
        self.baddies.remove(dude)
      
    
    for bullet in self.projectiles['Baddie']:
      bullet.update()
      
      if not bullet.alive and not bullet.exploding:
        self.projectiles['Baddie'].remove(bullet)
      
    
  
